Subject: Re: [PATCH v4 2/8] socket: initial cgroup code.

From: Glauber Costa <[email-masked]>
Date: Mon, 3 Oct 2011 15:03:35 +0400

On 10/03/2011 03:02 PM, Kirill A. Shutemov wrote:
> On Mon, Oct 03, 2011 at 02:48:15PM +0400, Glauber Costa wrote:
>> On 10/03/2011 02:47 PM, Kirill A. Shutemov wrote:
>>> On Mon, Oct 03, 2011 at 02:18:37PM +0400, Glauber Costa wrote:
>>>> We aim to control the amount of kernel memory pinned at any
>>>> time by tcp sockets. To lay the foundations for this work,
>>>> this patch adds a pointer to the kmem_cgroup to the socket
>>>> structure.
>>>>
>>>> Signed-off-by: Glauber Costa<[email-masked]>
>>>> CC: David S. Miller<[email-masked]>
>>>> CC: Hiroyouki Kamezawa<[email-masked]>
>>>> CC: Eric W. Biederman<[email-masked]>
>>>> ---
>>>>    include/linux/memcontrol.h |   15 +++++++++++++++
>>>>    include/net/sock.h         |    2 ++
>>>>    mm/memcontrol.c            |   33 +++++++++++++++++++++++++++++++++
>>>>    net/core/sock.c            |    3 +++
>>>>    4 files changed, 53 insertions(+), 0 deletions(-)
>>>>
>>>> diff --git a/include/linux/memcontrol.h b/include/linux/memcontrol.h
>>>> index 3b535db..2cb9226 100644
>>>> --- a/include/linux/memcontrol.h
>>>> +++ b/include/linux/memcontrol.h
>>>> @@ -395,5 +395,20 @@ mem_cgroup_print_bad_page(struct page *page)
>>>>    }
>>>>    #endif
>>>>
>>>> +#ifdef CONFIG_INET
>>>> +struct sock;
>>>> +#ifdef CONFIG_CGROUP_MEM_RES_CTLR_KMEM
>>>> +void sock_update_memcg(struct sock *sk);
>>>> +void sock_release_memcg(struct sock *sk);
>>>> +
>>>> +#else
>>>> +static inline void sock_update_memcg(struct sock *sk)
>>>> +{
>>>> +}
>>>> +static inline void sock_release_memcg(struct sock *sk)
>>>> +{
>>>> +}
>>>> +#endif /* CONFIG_CGROUP_MEM_RES_CTLR_KMEM */
>>>> +#endif /* CONFIG_INET */
>>>>    #endif /* _LINUX_MEMCONTROL_H */
>>>>
>>>> diff --git a/include/net/sock.h b/include/net/sock.h
>>>> index 8e4062f..afe1467 100644
>>>> --- a/include/net/sock.h
>>>> +++ b/include/net/sock.h
>>>> @@ -228,6 +228,7 @@ struct sock_common {
>>>>      *	@sk_security: used by security modules
>>>>      *	@sk_mark: generic packet mark
>>>>      *	@sk_classid: this socket's cgroup classid
>>>> +  *	@sk_cgrp: this socket's kernel memory (kmem) cgroup
>>>>      *	@sk_write_pending: a write to stream socket waits to start
>>>>      *	@sk_state_change: callback to indicate change in the state of the sock
>>>>      *	@sk_data_ready: callback to indicate there is data to be processed
>>>> @@ -339,6 +340,7 @@ struct sock {
>>>>    #endif
>>>>    	__u32			sk_mark;
>>>>    	u32			sk_classid;
>>>> +	struct mem_cgroup	*sk_cgrp;
>>>>    	void			(*sk_state_change)(struct sock *sk);
>>>>    	void			(*sk_data_ready)(struct sock *sk, int bytes);
>>>>    	void			(*sk_write_space)(struct sock *sk);
>>>> diff --git a/mm/memcontrol.c b/mm/memcontrol.c
>>>> index 8aaf4ce..08a520e 100644
>>>> --- a/mm/memcontrol.c
>>>> +++ b/mm/memcontrol.c
>>>> @@ -339,6 +339,39 @@ struct mem_cgroup {
>>>>    	spinlock_t pcp_counter_lock;
>>>>    };
>>>>
>>>> +/* Writing them here to avoid exposing memcg's inner layout */
>>>> +#ifdef CONFIG_CGROUP_MEM_RES_CTLR_KMEM
>>>> +#ifdef CONFIG_INET
>>>> +#include<net/sock.h>
>>>> +
>>>> +void sock_update_memcg(struct sock *sk)
>>>> +{
>>>> +	/* right now a socket spends its whole life in the same cgroup */
>>>> +	BUG_ON(sk->sk_cgrp);
>>>
>>> Do we really want to panic in this case?
>>>
>>> What about WARN() + return?
>>
>> Kirill,
>>
>> I am keeping this code just to have something workable in between.
>> If you take a look at the last patch, this hunk is going away anyway.
>>
>> So if you don't oppose it, I'll just keep it to avoid rebasing it.
>
> Sorry, but I don't see where you remove BUG_ON().
> You remove only cgroup_exclude_rmdir().
>
Oh yeah, you are right, sorry.

So, I guess some kind of check is sane here. I am happy to change it to 
WARN_ON.